/* 
 * $Id: command.h 32 2009-06-07 20:11:05Z ths $
 *
 * Keykeriki wireless keyboard sniffer 
 * command parser routine(s)
 *
 * Authors/Copyright:
 *    Thorsten Schroeder <ths  (at)  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * Switzerland, Berne, 2009/04/22
 * Germany, Berlin, 2009/05/08
 *
 * */

#ifndef _COMMAND_H
#define _COMMAND_H
#include <avr/pgmspace.h>

int8_t process_cmd(char *, char *, uint16_t);
int8_t keykeriki_cmd_help(char *, char *, uint16_t);
int8_t keykeriki_cmd_rssi(char *, char *, uint16_t);
int8_t keykeriki_cmd_reboot(char *, char *, uint16_t);
int8_t keykeriki_cmd_key(char *, char *, uint16_t);
int8_t keykeriki_cmd_trf(char *, char *, uint16_t);
int8_t keykeriki_cmd_sdcard(char *, char *, uint16_t);
int8_t keykeriki_cmd_cfg(char *, char *, uint16_t);
int8_t keykeriki_cmd_free(char *, char *, uint16_t);


typedef struct __kk_cmd_handler {
   PGM_P name;
   PGM_P desc;
   int8_t (*func) (char *, char *, uint16_t);
} keykeriki_cmd_handler;

/* ----------------------------------------- */

#define CMD_ERR   -1
#define CMD_OK    0

#endif

