/* 
 * $Id: eeprom.c 32 2009-06-07 20:11:05Z ths $
 *
 * Keykeriki wireless keyboard sniffer 
 * eeprom data structures
 *
 * Authors/Copyright:
 *    Thorsten Schroeder <ths  (at)  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * Germany, Berlin, 2009/05/09
 *
 * */
#include <avr/io.h>
#include <avr/eeprom.h>

#include "main.h"
#include "trf7900.h"

#ifndef EEMEM
#undef EEMEM
#define EEMEM __attribute__ ((section(".eeprom")))
#endif

uint16_t ee_hdr_dummy      EEMEM = 0x0000;

uint8_t  ee_trf7900_addr   EEMEM = TRF7900_ADDR;   /* default */
uint8_t  ee_trf7900_mode   EEMEM = TRF_ON;         /* default */
uint8_t  ee_trf7900_res    EEMEM = 0;              /* default */
uint8_t  ee_trf7900_freq_a EEMEM = CHAN_3;
uint8_t  ee_trf7900_freq_b EEMEM = CHAN_4;

uint8_t  ee_cfg_enable_secondary_uart  EEMEM = 0;  /* nope */
uint8_t  ee_cfg_enable_rssi            EEMEM = 0;  /* nope */
uint8_t  ee_cfg_enable_crack           EEMEM = 1;  /* yo */
uint8_t  ee_cfg_enable_usb             EEMEM = 1;  /* yo */
uint8_t  ee_cfg_enable_sdcard          EEMEM = 1;  /* yo */
uint8_t  ee_cfg_enable_sdcard_append   EEMEM = 1;  /* yo */
uint8_t  ee_cfg_enable_decrypt         EEMEM = 1;  /* yo */
uint8_t  ee_cfg_kbd_vendor             EEMEM = KBD_VENDOR_MS;  /* default */
uint8_t  ee_cfg_kbd_model              EEMEM = KBD_MODEL_MS1000;  /* default */
uint32_t ee_cfg_usart1_baud            EEMEM = 57600UL; /* USB */
uint32_t ee_cfg_usart0_baud            EEMEM = 38400UL; /* backpack stuff */

uint8_t  ee_cfg_crypto_key_a           EEMEM = 0;  /* MS crypto key chan a */
uint8_t  ee_cfg_crypto_key_b           EEMEM = 0;  /* MS crypto key chan b */

