
/* 
 * $Id: helper.c 32 2009-06-07 20:11:05Z ths $
 *
 * useful helper functions
 *
 * Authors/Copyright:
 *    Thorsten Schroeder <ths  (at)  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * germany, Berlin, 2009/04/22
 *
 * */


#include <string.h>
#include <stdio.h>
#include <ctype.h>

#include "helper.h"

#ifdef MAIN
   #undef serial_write_str
   #define serial_write_str printf

#else
#include "serial.h"

#endif

/*
 * print data in rows of 16 bytes: offset   hex   ascii
 *
 * 00000   47 45 54 20 2f 20 48 54  54 50 2f 31 2e 31 0d 0a   GET / HTTP/1.1..
 */
void print_hex_ascii_line(const unsigned char *payload, int slen, int offset)
{

	int i;
	int gap, len;
	const unsigned char *ch, *ch2;

   len = 16;
   ch2 = ch = payload;

  do {
      
      /* offset */
      printf("%05x   ", offset);
      
      /* hex */
      if(slen < len)
         len=slen;

      for(i = 0; i < len; i++) {
         printf("%02x ", *ch);
         ch++;
         /* print extra space after 8th byte for visual aid */
         if (i == 7)
            putc(' ', stdout);
      }
      /* print space to handle line less than 8 bytes */
      if (len < 8)
         putc(' ', stdout);
      
      /* fill hex gap with spaces if not full line */
      if (len < 16) {
         gap = 16 - len;
         for (i = 0; i < gap; i++) {
            printf("   ");
         }
      }          
      printf("   ");
      
      /* ascii (if printable) */
      for(i = 0; i < len; i++) {
         if (isprint(*ch2)){
            printf("%c", *ch2);
         } else
            putc(' ', stdout);
         ch2++;
      }

      printf("\n\r");
      slen -= 16;
      offset += len;
   } while( slen > 0 ) ;

  
   return;
}

//void hex_out(char *desc, void *bin, int len)
void hex_out(uint16_t desc, uint8_t *bin, uint8_t len)
{  
   uint8_t i = 0;
   
   //printf("%04x: ", desc);

   for(i=0; i<8; i++) {
      /*
       if(j >= BPL) {
         puts("\r\n");
         j = 0;
      }
      j++;
      */
      printf("%02x ", bin[i]);
   }
   puts("\r\n");
//   printf(" [[%d]] \r\n", len);
}

