
/* 
 * $Id: hidcodes.h 32 2009-06-07 20:11:05Z ths $
 *
 * Microsoft keyboard specific Miller Decoding for 8-bit microcontrollers
 * HID code tables
 *
 * Authors/Copyright:
 *    Max Moser <mmo  (at)  remote-exploit.org>
 *    Thorsten Schroeder <ths  (at)  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * Switzerland, Berne, 2009/04/22
 *
 * */

uint8_t HID_basic[][2] = {
   /*0x00=>*/{'_','_'},
   /*0x01=>*/{'_','_'},
   /*0x02=>*/{'_','_'},
   /*0x03=>*/{'_','_'},
   /*0x04=>*/{'a','A'},
   /*0x05=>*/{'b','B'},
   /*0x06=>*/{'c','C'},
   /*0x07=>*/{'d','D'},
   /*0x08=>*/{'e','E'},
   /*0x09=>*/{'f','F'},
   /*0x0A=>*/{'g','G'},
   /*0x0B=>*/{'h','H'},
   /*0x0C=>*/{'i','I'},
   /*0x0D=>*/{'j','J'},
   /*0x0E=>*/{'k','K'},
   /*0x0F=>*/{'l','L'},
   /*0x10=>*/{'m','M'},
   /*0x11=>*/{'n','N'},
   /*0x12=>*/{'o','O'},
   /*0x13=>*/{'p','P'},
   /*0x14=>*/{'q','Q'},
   /*0x15=>*/{'r','R'},
   /*0x16=>*/{'s','S'},
   /*0x17=>*/{'t','T'},
   /*0x18=>*/{'u','U'},
   /*0x19=>*/{'v','V'},
   /*0x1A=>*/{'w','W'},
   /*0x1B=>*/{'x','X'},
   /*0x1C=>*/{'y','Y'},
   /*0x1D=>*/{'z','Z'},
   /*0x1E=>*/{'1','!'},
   /*0x1F=>*/{'2','@'},
   /*0x20=>*/{'3','#'},
   /*0x21=>*/{'4','$'},
   /*0x22=>*/{'5','%'},
   /*0x23=>*/{'6','^'},
   /*0x24=>*/{'7','&'},
   /*0x25=>*/{'8','*'},
   /*0x26=>*/{'9','('},
   /*0x27=>*/{'0',')'},
   /*0x28=>*/{'\n','\n'},
   /*0x29=>*/{'_','_'},
   /*0x2A=>*/{0x08,0x08},
   /*0x2B=>*/{'\t','\t'},
   /*0x2C=>*/{' ',' '},
   /*0x2D=>*/{'-','_'},
   /*0x2E=>*/{'=','+'},
   /*0x2F=>*/{'[','{'},
   /*0x30=>*/{'}','}'},
   /*0x31=>*/{'\\','|'},
   /*0x32=>*/{'_','_'},
   /*0x33=>*/{';',':'},
   /*0x34=>*/{'\'','\"'},
   /*0x35=>*/{'`','~'},
   /*0x36=>*/{',','<'},
   /*0x37=>*/{'.','>'},
   /*0x38=>*/{'/','?'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'},
   /*0x39=>*/{'_','_'}
};
/*  0x81=>["SystemPower"],
    0x82=>["SystemSleep"],
    0x83=>["SystemWake"],
*/
/*
my %HID_advanced = (
    0x68=>["F13",],
    0x69=>["F14",],
    0x6A=>["F15",],
    0x6B=>["F16",],
    0x6C=>["F17",],
    0x6D=>["F18",],
    0x6E=>["F19",],
    0x6F=>["F20",],
    0x70=>["F21",],
    0x71=>["F22",],
    0x72=>["F23",],
    0x73=>["F24",],
    0x74=>["KeyboardExecute",],
    0x75=>["KeyboardHelp",],
    0x76=>["KeyboardMenu",],
    0x77=>["KeyboardSelect",],
    0x78=>["KeyboardStop",],
    0x79=>["KeyboardAgain",],
    0x7A=>["KeyboardUndo",],
    0x7B=>["KeyboardCut",],
    0x7C=>["KeyboardCopy",],
    0x7D=>["KeyboardPaste",],
    0x7E=>["KeyboardFind",],
    0x7F=>["KeyboardMute",],
    0x80=>["KeyboardVolumeUp",],
    0x81=>["KeyboardVolumeDn",],
    0x82=>["KeyboardLockingCapsLock",],
    0x83=>["KeyboardLockingNumLock",],
    0x84=>["KeyboardLockingScrollLock",],
    0x85=>["Keypad,(BrazilianKeypad.)",],
    0x86=>["KeyboardEqualSign",],
    0x87=>["KeyboardInt'l1(Ro)",],
    0x88=>["KeyboardIntl'2(Katakana/Hiragana)",],
    0x89=>["KeyboardInt'l2(Yen)",],
    0x8A=>["KeyboardInt'l4(Henkan)",],
    0x8B=>["KeyboardInt'l5(Muhenkan)",],
    0x8C=>["KeyboardInt'l6(PC9800Keypad,)",],
    0x8D=>["KeyboardInt'l7",],
    0x8E=>["KeyboardInt'l8",],
    0x8F=>["KeyboardInt'l9",],
    0x01=>["OverrunError"],
    0x02=>["POSTFail"],
    0x03=>["ErrorUndefined"],
    0x04=>["a","A"],
    0x05=>["b","B"],
    0x06=>["c","C"],
    0x07=>["d","D"],
    0x08=>["e","E"],
    0x09=>["f","F"],
    0x0A=>["g","G"],
    0x0B=>["h","H"],
    0x0C=>["i","I"],
    0x0D=>["j","J"],
    0x0E=>["k","K"],
    0x0F=>["l","L"],
    0x10=>["m","M"],
    0x11=>["n","N"],
    0x12=>["o","O"],
    0x13=>["p","P"],
    0x14=>["q","Q"],
    0x15=>["r","R"],
    0x16=>["s","S"],
    0x17=>["t","T"],
    0x18=>["u","U"],
    0x19=>["v","V"],
    0x1A=>["w","W"],
    0x1B=>["x","X"],
    0x1C=>["y","Y"],
    0x1D=>["z","Z"],
    0x1E=>["1","!"],
    0x1F=>["2","@"],
    0x20=>["3","#"],
    0x21=>["4","\$"],
    0x22=>["5","%"],
    0x23=>["6","^"],
    0x24=>["7","&"],
    0x25=>["8","*"],
    0x26=>["9","("],
    0x27=>["0",")"],
    0x28=>["Return","Return"],
    0x29=>["Escape","Escape"],
    0x2A=>["Backspace","Backspace"],
    0x2B=>["Tab","Tab"],
    0x2C=>["Space","Space"],
    0x2D=>["-","_"],
    0x2E=>["=","+"],
    0x2F=>["[","{"],
    0x30=>["]","}"],
    0x31=>["\\","|"],
    0x32=>["Europe1(Note2)","Europe1(Note2)"],
    0x33=>[";",":"],
    0x34=>["'","\""],
    0x35=>["`","~"],
    0x36=>[",","<"],
    0x37=>[".",">"],
    0x38=>["/","?"],
    0x39=>["CapsLock","CapsLock"],
    0x3A=>["F1","F1"],
    0x3B=>["F2","F2"],
    0x3C=>["F3","F3"],
    0x3D=>["F4","F4"],
    0x3E=>["F5",],
    0x3F=>["F6",],
    0x40=>["F7",],
    0x41=>["F8",],
    0x42=>["F9",],
    0x43=>["F10",],
    0x44=>["F11",],
    0x45=>["F12",],
    0x46=>["PrintScreen(Note1)"],
    0x47=>["ScrollLock"],
    0x48=>["Break(Ctrl-Pause)"],
    0x48=>["Pause"],
    0x49=>["Insert(Note1)"],
    0x4A=>["Home(Note1)"],
    0x4B=>["PageUp(Note1)"],
    0x4C=>["Delete(Note1)"],
    0x4D=>["End(Note1)"],
    0x4E=>["PageDown(Note1)"],
    0x4F=>["RightArrow(Note1)"],
    0x50=>["LeftArrow(Note1)"],
    0x51=>["DownArrow(Note1)"],
    0x52=>["UpArrow(Note1)"],
    0x53=>["NumLock"],
    0x54=>["Keypad/(Note1)"],
    0x55=>["Keypad*"],
    0x56=>["Keypad-"],
    0x57=>["Keypad+"],
    0x58=>["KeypadEnter"],
    0x59=>["Keypad1End"],
    0x5A=>["Keypad2Down"],
    0x5B=>["Keypad3PageDn"],
    0x5C=>["Keypad4Left"],
    0x5D=>["Keypad5"],
    0x5E=>["Keypad6Right"],
    0x5F=>["Keypad7Home",],
    0x60=>["Keypad8Up",],
    0x61=>["Keypad9PageUp",],
    0x62=>["Keypad0Insert",],
    0x63=>["Keypad.Delete",],
    0x64=>["Europe2(Note2)",],
    0x65=>["App",],
    0x66=>["KeyboardPower",],
    0x67=>["Keypad=",],
    0x90=>["KeyboardLang1(Hanguel/English)",],
    0x91=>["KeyboardLang2(Hanja)",],
    0x92=>["KeyboardLang3(Katakana)",],
    0x93=>["KeyboardLang4(Hiragana)",],
    0x94=>["KeyboardLang5(Zenkaku/Hankaku)",],
    0x95=>["KeyboardLang6",],
    0x96=>["KeyboardLang7",],
    0x97=>["KeyboardLang8",],
    0x98=>["KeyboardLang9",],
    0x99=>["KeyboardAlternateErase",],
    0x9A=>["KeyboardSysReq/Attention",],
    0x9B=>["KeyboardCancel",],
    0x9C=>["KeyboardClear",],
    0x9D=>["KeyboardPrior",],
    0x9E=>["KeyboardReturn",],
    0x9F=>["KeyboardSeparator",],
    0xA0=>["KeyboardOut",],
    0xA1=>["KeyboardOper",],
    0xA2=>["KeyboardClear/Again",],
    0xA3=>["KeyboardCrSel/Props",],
    0xA4=>["KeyboardExSel",],
    0xE0=>["LeftControl",],
    0xE1=>["LeftShift",],
    0xE2=>["LeftAlt",],
    0xE3=>["LeftGUI",],
    0xE4=>["RightControl",],
    0xE5=>["RightShift",],
    0xE6=>["RightAlt",],
    0xE7=>["RightGUI",],

);

my %valid_ms1000 = (
    # multimedia keys:
    0x7a => ["[MM-Key My Documents]",],
    0x7b => ["[MM-Key My Pictures]",],
    0x7c => ["[MM-Key My Music]",],
    0x81 => ["[MM-Key KeyboardVolumeDn]",],
    0x84 => ["[MM-Key Play/Pause]",],
    0x85 => ["[MM-Key Stop]",],
    0x82 => ["[MM-Key Minus]",],
    0x83 => ["[MM-Key Plus]",],
    0x86 => ["[MM-Key Prev]",],
    0x87 => ["[MM-Key Next]",],
    0x88 => ["[MM-Key Media]",],
    0x80 => ["[MM-Key Mail]",],
    0x7f => ["[MM-Key Web/Home]",],
    0x7e => ["[MM-Key Messenger]",],
    0x8a => ["[MM-Key Calculator]",],
    0x7d => ["[MM-Key LogOff]",],
    0x8b => ["[MM-Key Sleep]",],
    
    # special key
    0x79 => ["[SPECIAL F Lock]",],
);

*/


