/* 
 * $Id: inthandler.c 32 2009-06-07 20:11:05Z ths $
 *
 * Microsoft wireless keyboard sniffer 
 * Interrupt routine(s)
 *
 * Authors/Copyright:
 *    Max Moser <mmo  (at)  remote-exploit.org>
 *    Thorsten Schroeder <ths  (at)  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * Switzerland, Berne, 2009/04/22
 *
 * */

#include <avr/interrupt.h>
#include "serial.h"
#include "helper.h"
#include "main.h"
#include <string.h>

#include "fifo.h"

/* global variables from main.c */
extern long count;
extern int started;
extern int sync;
extern keykeriki_cmd cmd;

int begin = 1;


extern uint8_t prev_bit;
extern uint8_t result[8];
extern uint8_t idx;
extern miller_context ctx;


/* Interrupt code for capture interrupt */
ISR(TIMER1_CAPT_vect)
{
	/* According to specs we need to copy away ICR as fast as possible*/
	count=ICR1;
	
	/* Next should be flipping the detection up or down */
	TCCR1B ^= (1<<ICES1);
	
	// Set timer to 0 otherwise we wont get right numbers :-)
	TCNT1 = 0;

  ms_miller_decode(&ctx, count);
	
} // End of Capture interrupt code

ISR( USART1_RX_vect) {
   
   uint8_t c=0;

   if(cmd.lock == 1)
      return;

   cmd.lock=1;
   
   c = UDR1;

   if(c == '\r' || c == '\n')
      cmd.rdone = 1;
   else
      cmd.line[cmd.len++] = c; /* it's ok if this wraps around.
                                  the buffer is NULL terminated 
                                  in any case. */
   cmd.lock=0;
   putc(c, stdout); /* maybe we should move this to main() */
}
