/* 
 * $Id: miller.c 32 2009-06-07 20:11:05Z ths $
 *
 * Microsoft keyboard specific Miller Decoding for 8-bit microcontrollers
 *
 * Authors/Copyright:
 *    Max Moser <mmo  at  remote-exploit.org>
 *    Thorsten Schroeder <ths  at  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * Switzerland, Berne, 2009/04/22
 *
 * */

/*
 * ROAD WORKS AHEAD!
 *
 * THIS FILE IS RELEASED, BUT KIND OF OBSOLETE. 
 * NEW ALGO IS CURRENTLY BEING WRITTEN & TESTED
 *
 * */



#include <avr/interrupt.h>
#include "helper.h"
#include "main.h"
#include "fifo.h"
#include <string.h>
#include <stdio.h>

extern miller_context ctx;
extern fifo_t fifo;

#ifdef MAIN
#include <stdio.h>
#include <sys/types.h>
#endif


void miller_a(miller_context *ctx)
{
   uint8_t i = 0; /* index into ctx->data buffer */
   uint8_t b = 0; /* bit index */

   /* Got a miller A to decode */
   togglepin();

   /* last bit is different than current bit */
   i = ctx->__idx/8;
   b = 1<<(ctx->__idx % 8);

   if(ctx->__prev)
      ctx->data[i] &= ~(b);
   else
      ctx->data[i] |= b;

   ctx->__prev = ctx->data[i] & b;
   ctx->ptype = i;
   ctx->__idx++;
   return;
}

void miller_b(miller_context *ctx)
{
   uint8_t i = 0; /* index into ctx->data buffer */
   uint8_t b = 0; /* bit index */

   togglepin();
	
   /* Microsoft specific: 
   * If the previous bit is 1, the next two bits will be 1 and 0 
   * If the previous bit is 0, the next two bits will be 0 and 1 
   */

   i = ctx->__idx/8;
   b = 1<<(ctx->__idx % 8);

   if(ctx->__prev)
      ctx->data[i] |= b;
   else
      ctx->data[i] &= ~(b);

   ctx->__idx++;

   i = ctx->__idx/8;
   b = 1<<(ctx->__idx % 8);

   if(ctx->__prev)
      ctx->data[i] &= ~(b);
   else
      ctx->data[i] |= b; 

   ctx->__prev = ctx->data[i] & b;
   ctx->ptype = i;
   ctx->__idx++;
   return;
}

void miller_c(miller_context *ctx)
{

   uint8_t i = 0; /* index into ctx->data buffer */
   uint8_t b = 0; /* bit index */

   togglepin();

   /* Microsoft specific:
   * If previous bit is n, the next two bits are also n and n
   **/

   i = ctx->__idx/8;
   b = 1<<(ctx->__idx % 8);

   if(ctx->__prev)
      ctx->data[i] |= b; 

   ctx->__idx++;

   i = ctx->__idx/8;
   b = 1<<(ctx->__idx % 8);

   if(ctx->__prev)
      ctx->data[i] |= b; 

   ctx->__prev = ctx->data[i] & b;
   ctx->ptype = i;
   ctx->__idx++;

   return;
}

void miller_start(miller_context *ctx)
{
   /* We have a start condition */
   togglepin();
   
   memset(ctx, 0, sizeof(miller_context));
   
   ctx->sync    = 1;
   ctx->started = 1;
   ctx->__prev = 0;
   ctx->__idx  = 0;
     
   return;
}

void miller_stop(miller_context *ctx)
{
   togglepin();
	int i=0;
	
   ctx->started =0;

   /* Had to reset sync because data end means sync end as well */
   /* THIS HAS TO BE DISABLED AS A WORKAROUND. Otherwise we will miss a lot of
    * keystrokes, since a start does not depend on a SYN signal (ths) */
   //ctx->sync = 0; 

   fifo_put (&fifo, (ctx->ptype+1));

   for(i=0;i<7;i++) {
      fifo_put (&fifo, ctx->data[i]);
   }

   ctx->__prev = 0;
   ctx->__idx  = 0;
   return;
}

#define MILLERSTART(ctx,x) ( \
      ((x) >= (SDATA-5)) && \
      ((x) <= (SDATA+5)) && \
      ((ctx)->sync == 1) && \
      ((ctx)->started == 0))
#define MILLERSTOP(ctx,x) ( \
      ((x) >= (SDATA-5)) && \
      ((x) <= (SDATA+5)) && \
      ((ctx)->sync == 1) && \
      ((ctx)->started == 1))
#define MILLERSYNC(ctx,x) \
   (((x) >= (SYNC-5)) && ((x) <= (SYNC+5)) && ((ctx)->sync == 0))	
#define MILLER_C(ctx,x) \
   (((x) >= (MILLERC-5)) && ((x) <= (MILLERC+5)) && ((ctx)->started==1))
#define MILLER_B(ctx,x) \
   (((x) >= (MILLERB-5)) && ((x) <= (MILLERB+5)) && ((ctx)->started==1))
#define MILLER_A(ctx,x) \
   (((x) >= (MILLERA-5)) && ((x) <= (MILLERA+5)) && ((ctx)->started==1))

void ms_miller_decode(miller_context *ctx, uint8_t signal)
{
   if(MILLERSYNC(ctx, signal)) {
      
      /* We found a sync lenght */
      togglepin();

      memset(ctx, 0, sizeof(miller_context));
      ctx->sync=1;
			ctx->started=0;
			
   } else if( MILLERSTART(ctx, signal)) {
      miller_start(ctx);
   } else if( MILLERSTOP(ctx, signal)) {
      miller_stop(ctx);
   } else if (MILLER_C(ctx, signal)) {
      miller_c(ctx);
   } else if (MILLER_B(ctx, signal)) {
      miller_b(ctx);
   } else if (MILLER_A(ctx, signal)) {
      miller_a(ctx);
   }	else if (ctx->started == 1 ) {
   	miller_stop(ctx);
   } //else
   	//togglepin(); /* debugging */
   

} /* End of Capture interrupt code */
