/* 
 * $Id: sd.h 32 2009-06-07 20:11:05Z ths $
 *
 * SD Card access
 *
 * Author(s)/Copyright:
 *    2009 Thorsten Schroeder <ths  (at)  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * Germany, Berlin, 2009/04/24
 *
 * */


#ifndef _SD_H
#define _SD_H

/* config */
#define SD_PORT   PORTB
#define SD_PIN    PINB
#define SD_DDR    DDRB

#define SD_MISO   3     /* in (SD-DO) */
#define SD_MOSI   2     /* out (SD-DI) */
#define SD_SCK    1
#define SD_CS     0
#define SD_SS     0

#define DATA_BLOCK_SIZE 512
#define RECORD_SIZE 16

/* SD/MMC commands */

#define CMD0   {0x40,0x00,0x00,0x00,0x00,0x95}
#define CMD24  {0x58,0x00,0x00,0x00,0x00,0xff}
#define CMD17  {0x51,0x00,0x00,0x00,0x00,0xff}


/* prototypes */
uint8_t sd_init(void);
uint8_t sd_fs_update_header(unsigned long, uint8_t *);
unsigned long sd_last_sector(void);
uint8_t sd_store(uint8_t *, uint16_t);

void sd_disable(uint8_t);
void sd_enable(uint8_t);
uint8_t sd_append(void);

/* useful macros */
#define SD_DISABLE() (SD_PORT |= (1<<SD_CS))
#define SD_ENABLE()  (SD_PORT &= ~(1<<SD_CS))

#endif
