/* 
 * $Id: trf7900.h 32 2009-06-07 20:11:05Z ths $
 *
 * Keykeriki wireless keyboard sniffer 
 * command parser routine(s)
 *
 * Authors/Copyright:
 *    Thorsten Schroeder <ths  (at)  dev.io>
 *
 * Revision: $Rev: 32 $
 *
 * Germany, Berlin, 2009/05/09
 *
 * */

#ifndef _TRF7900_H
#define _TRF7900_H

/* 7-bit I2C address of the TRF7900*/
#define TRF7900_ADDR   0b1101100

/* TRF7900 boot delay (min: 20 ms) */
#define TRFBOOTWAIT  100

/* TRF7900 Power Modes */
#define TRF_ON    0b0
#define TRF_OFF   0b1

#define TRF_CHAN_A 1
#define TRF_CHAN_B 2

/* TRF7900 configuration via I2C (send after SDA is pulled low by TRF)
 * Power down bit | Frequency A | res. bit | Frequency B 
 * TRF_ON           FREQ26995MHZ  0          FREQ26995MHZ  
 * 0                000           0          000
 * -> 0x00000000
 *
 * */

/* I2C codes for programmable channels */
enum __e_trf9700_frequency_selection {
   FREQ26995MHZ,
   FREQ27045MHZ,
   FREQ27095MHZ,
   FREQ27145MHZ,
   FREQ27195MHZ,
   FREQ27245MHZ,
   FREQ27295MHZ,
   FREQ26945MHZ
} e_trf_freq;

/* I2C codes for programmable channels */
enum __e_trf9700_frequency_channel {
   CHAN_0,
   CHAN_1,
   CHAN_2,
   CHAN_3,
   CHAN_4,
   CHAN_5,
   CHAN_6,
   CHAN_7
} e_trf_chan;


typedef uint8_t trf_addr_t;

uint8_t trf7900_init(trf_addr_t);
uint8_t trf7900_setfreq(uint8_t, uint8_t);

uint8_t trf7900_getaddr(void);  
uint8_t trf7900_getmode(void);  
uint8_t trf7900_getres(void);   
uint8_t trf7900_getfreq_a(void);
uint8_t trf7900_getfreq_b(void);


uint8_t trf7900_getfreq(uint8_t chan);



#endif

